Bug 1796225 (CVE-2020-7238) - CVE-2020-7238 netty: HTTP Request Smuggling due to Transfer-Encoding whitespace mishandling
Summary: CVE-2020-7238 netty: HTTP Request Smuggling due to Transfer-Encoding whitespa...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2020-7238
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1796276 1796317 1796318 1796319 1796320 1796321 1796323 1796610 1797630 1797631 1797632 1825800
Blocks: 1796227
TreeView+ depends on / blocked
 
Reported: 2020-01-29 22:31 UTC by Pedro Sampaio
Modified: 2020-06-01 09:00 UTC (History)
109 users (show)

Fixed In Version: netty 4.1.44.Final
Doc Type: If docs needed, set a value
Doc Text:
A flaw was found in Netty, where it mishandles Transfer-Encoding whitespace. This flaw allows HTTP Request Smuggling.
Clone Of:
Environment:
Last Closed: 2020-02-13 20:09:37 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2020:0497 None None None 2020-02-13 14:51:10 UTC
Red Hat Product Errata RHSA-2020:0567 None None None 2020-03-03 16:13:24 UTC
Red Hat Product Errata RHSA-2020:0601 None None None 2020-02-25 15:30:36 UTC
Red Hat Product Errata RHSA-2020:0605 None None None 2020-02-25 17:34:24 UTC
Red Hat Product Errata RHSA-2020:0606 None None None 2020-02-25 17:27:34 UTC
Red Hat Product Errata RHSA-2020:0804 None None None 2020-03-12 17:04:39 UTC
Red Hat Product Errata RHSA-2020:0805 None None None 2020-03-12 17:06:16 UTC
Red Hat Product Errata RHSA-2020:0806 None None None 2020-03-12 17:01:42 UTC
Red Hat Product Errata RHSA-2020:0811 None None None 2020-03-12 17:00:46 UTC
Red Hat Product Errata RHSA-2020:0922 None None None 2020-03-23 08:23:11 UTC
Red Hat Product Errata RHSA-2020:0939 None None None 2020-03-23 13:21:10 UTC
Red Hat Product Errata RHSA-2020:0951 None None None 2020-03-23 20:14:10 UTC
Red Hat Product Errata RHSA-2020:1445 None None None 2020-04-14 13:05:33 UTC
Red Hat Product Errata RHSA-2020:2067 None None None 2020-05-18 10:27:45 UTC
Red Hat Product Errata RHSA-2020:2321 None None None 2020-05-26 16:10:10 UTC
Red Hat Product Errata RHSA-2020:2333 None None None 2020-05-28 15:59:45 UTC

Description Pedro Sampaio 2020-01-29 22:31:48 UTC
Netty 4.1.43.Final allows HTTP Request Smuggling because it mishandles Transfer-Encoding whitespace (such as a [space]Transfer-Encoding:chunked line) and a later Content-Length header. This issue exists because of an incomplete fix for CVE-2019-16869.

References:

https://github.com/jdordonezn/CVE-2020-72381/issues/1
https://netty.io/news/

Comment 2 Summer Long 2020-01-30 02:03:12 UTC
External References:

https://netty.io/news/2019/12/18/4-1-44-Final.html

Comment 3 Summer Long 2020-01-30 04:13:55 UTC
Created netty tracking bugs for this issue:

Affects: fedora-all [bug 1796276]

Comment 14 Yadnyawalk Tale 2020-02-04 05:16:11 UTC
Statement:

OpenShift Container Platform ships a vulnerable netty library as part of the logging-elasticsearch5 container. ElasticSearch's security team has stated that the previous vulnerability, CVE-2019-16869, does not poses a substantial practical threat to ElasticSearch 6 [1]. We agree that this issue would be difficult to exploit both these vulnerabilities on OpenShift Container Platform, so we're reducing the impact of this issue to moderate and may fix it in the future release.

Red Hat Satellite ships vulnerable netty version embedded in Candlepin, however, is not directly vulnerable since HTTP requests are handled by Tomcat and not netty.

[1]  https://github.com/elastic/elasticsearch/issues/49396

Comment 16 Ted (Jong Seok) Won 2020-02-04 08:25:52 UTC
This vulnerability is out of security support scope for the following product:
 * Red Hat JBoss Operations Network 3

Please refer to https://access.redhat.com/support/policy/updates/jboss_notes for more details.

Comment 21 Jonathan Christison 2020-02-13 12:08:41 UTC
Mitigation:

* Use HTTP/2 instead (clear boundaries between requests)
* Disable reuse of backend connections eg. ```http-reuse never``` in HAProxy or whatever equivalent LB settings

Comment 22 errata-xmlrpc 2020-02-13 14:51:05 UTC
This issue has been addressed in the following products:

  Red Hat AMQ Online 1.3.3 GA

Via RHSA-2020:0497 https://access.redhat.com/errata/RHSA-2020:0497

Comment 23 Product Security DevOps Team 2020-02-13 20:09:37 UTC
This bug is now closed. Further updates for individual products will be reflected on the CVE page(s):

https://access.redhat.com/security/cve/cve-2020-7238

Comment 25 errata-xmlrpc 2020-02-25 15:30:32 UTC
This issue has been addressed in the following products:

  AMQ Clients 2.y for RHEL 7
  AMQ Clients 2.y for RHEL 8
  AMQ Clients 2.y for RHEL 6

Via RHSA-2020:0601 https://access.redhat.com/errata/RHSA-2020:0601

Comment 26 errata-xmlrpc 2020-02-25 17:27:28 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:0606 https://access.redhat.com/errata/RHSA-2020:0606

Comment 27 errata-xmlrpc 2020-02-25 17:34:20 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6
  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7
  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2020:0605 https://access.redhat.com/errata/RHSA-2020:0605

Comment 31 errata-xmlrpc 2020-03-03 16:13:20 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2020:0567 https://access.redhat.com/errata/RHSA-2020:0567

Comment 32 Jonathan Christison 2020-03-12 15:16:00 UTC
Marking AMQ-6 as low as it only uses netty in the context of integration tests, activemq components do not directly rely upon netty.

Comment 33 errata-xmlrpc 2020-03-12 17:00:41 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform

Via RHSA-2020:0811 https://access.redhat.com/errata/RHSA-2020:0811

Comment 34 errata-xmlrpc 2020-03-12 17:01:38 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 8

Via RHSA-2020:0806 https://access.redhat.com/errata/RHSA-2020:0806

Comment 35 errata-xmlrpc 2020-03-12 17:04:34 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 6

Via RHSA-2020:0804 https://access.redhat.com/errata/RHSA-2020:0804

Comment 36 errata-xmlrpc 2020-03-12 17:06:11 UTC
This issue has been addressed in the following products:

  Red Hat JBoss Enterprise Application Platform 7.2 for RHEL 7

Via RHSA-2020:0805 https://access.redhat.com/errata/RHSA-2020:0805

Comment 38 errata-xmlrpc 2020-03-23 08:22:59 UTC
This issue has been addressed in the following products:

  Red Hat AMQ

Via RHSA-2020:0922 https://access.redhat.com/errata/RHSA-2020:0922

Comment 39 errata-xmlrpc 2020-03-23 13:21:04 UTC
This issue has been addressed in the following products:

  Red Hat JBoss AMQ

Via RHSA-2020:0939 https://access.redhat.com/errata/RHSA-2020:0939

Comment 40 errata-xmlrpc 2020-03-23 20:14:03 UTC
This issue has been addressed in the following products:

  Red Hat Single Sign-On

Via RHSA-2020:0951 https://access.redhat.com/errata/RHSA-2020:0951

Comment 41 errata-xmlrpc 2020-04-14 13:05:28 UTC
This issue has been addressed in the following products:

  Red Hat AMQ 7.4.3

Via RHSA-2020:1445 https://access.redhat.com/errata/RHSA-2020:1445

Comment 43 errata-xmlrpc 2020-05-18 10:27:37 UTC
This issue has been addressed in the following products:

  Red Hat Openshift Application Runtimes

Via RHSA-2020:2067 https://access.redhat.com/errata/RHSA-2020:2067

Comment 44 errata-xmlrpc 2020-05-26 16:10:05 UTC
This issue has been addressed in the following products:

  Red Hat Data Grid 7.3.6

Via RHSA-2020:2321 https://access.redhat.com/errata/RHSA-2020:2321

Comment 45 errata-xmlrpc 2020-05-28 15:59:41 UTC
This issue has been addressed in the following products:

  EAP-CD 19 Tech Preview

Via RHSA-2020:2333 https://access.redhat.com/errata/RHSA-2020:2333


Note You need to log in before you can comment on or make changes to this bug.